; ************************************************************************************************
; * DMX zu WS2801/TM1804 fr SEDU-Board														 	 *
; * Konfigurationen																	 			 *
; ************************************************************************************************

; ================================================================================================
; Ports I/O setzen etc.
; ------------------------------------------------------------------------------------------------

		sbi		SEDU_DDR, S_LED					; Port fr Status-LED auf Ausgang
		cbi		SEDU_PORT, S_LED				; Status-LED an

		sbi		SEDU_DDR, RS485DIR				; Port fr RS485-Bustreiber-Richtung auf Ausgang

		in		temp0, DDRA						; Pullups an allen Eingngen
		com		temp0
		out		PortA, temp0

		in		temp0, DDRB						; Pullups an allen Eingngen
		com		temp0
		out		PortB, temp0

		in		temp0, DDRC						; Pullups an allen Eingngen
		com		temp0
		out		PortC, temp0

		in		temp0, DDRD						; Pullups an allen Eingngen
		com		temp0
		out		PortD, temp0

; ================================================================================================
; Stackpointer setzen
; ------------------------------------------------------------------------------------------------

		ldi 	temp0, HIGH(RAMEND)				; HIGH-Byte der obersten RAM-Adresse
		out 	SPH, temp0						; in den Stackpointer
		ldi 	temp0, LOW(RAMEND)				; LOW-Byte der obersten RAM-Adresse
		out 	SPL, temp0						; in den Stackpointer

; ================================================================================================
; USART0 konfigurieren fr USB
; ------------------------------------------------------------------------------------------------

.if BAUD_USB == 250000

	.equ UBRR_VAL =((XTAL+BAUD_USB*8)/(BAUD_USB*16)-1) 	; UBBR ausrechnen fr 250 k

.endif

.if BAUD_USB == 500000

	.equ UBRR_VAL = ((XTAL+BAUD_USB*4)/(BAUD_USB*8)-1) 	; UBBR ausrechnen fr 500 k

.endif

	   	ldi 	temp0, UBRR_VAL			 		; Usart auf Baudrate setzen
    	sts 	UBRR0L, temp0
    	clr 	temp0
    	sts 	UBRR0H, temp0

.if BAUD_USB == 500000

		ldi		temp0, (1<<U2X0)
		sts		UCSR0A, temp0			 		; Double Speed fr 500 kBaud

.endif

    	ldi 	temp0, (3<<UCSZ00)				; 8 Datenbits, 1 Stoppbit
    	sts 	UCSR0C, temp0			

		ldi		temp0, (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0) ; Rx, Tx, RxComplInt. enable
		sts		UCSR0B, temp0

		clr		temp0
		sts		tpm2_State, temp0				; Receiver Reset

; ================================================================================================
; USART1 konfigurieren fr DMX
; ------------------------------------------------------------------------------------------------

.equ UBRR_DMX =((XTAL+BAUD_DMX*8)/(BAUD_DMX*16)-1)  	; UBBR ausrechnen

	   	ldi 	temp0, UBRR_DMX			 		; Usart auf Baudrate DMX setzen
    	sts 	UBRR1L, temp0
    	clr 	temp0
    	sts 	UBRR1H, temp0

    	ldi 	temp0, (3<<UCSZ10)				; 8 Datenbits, 1 Stoppbit
    	sts 	UCSR1C, temp0			

		ldi		temp0, (1<<RXEN1)|(1<<RXCIE1) 	; Rx, RxComplInt. enable
		sts		UCSR1B, temp0

		clr		temp0
		sts		DMX_state,temp0					; Start-Status: auf Frame Error warten

		cbi		SEDU_PORT, RS485DIR				; Bustreiber auf Empfangen

; ------------------------------------------------------------------------------------------------
; DMX-Startadresse setzen
; ------------------------------------------------------------------------------------------------

		ldi		temp0, High(DMX_STARTADRESS)
		sts		DMX_Adress_H, temp0

		ldi		temp0, Low(DMX_STARTADRESS)
		sts		DMX_Adress_L, temp0

; ================================================================================================
; Timer 0 konfigurieren fr Receiver-Timeout etc.
; ------------------------------------------------------------------------------------------------

		ldi     temp0, (1<<CS02)	   			; Normal Mode, Prescaler auf 256, Timer starten
		out		TCCR0B, temp0

		ldi     temp0, (1<<TOIE0)      			; TOIE0: Interrupt bei Timer0 Overflow
		sts     TIMSK0, temp0

; ================================================================================================
; Div. Grundeinstellungen
; ------------------------------------------------------------------------------------------------

		clr		Flags							; Alle Flags lschen

; ================================================================================================

		sei										; Interrupts aktivieren

; ================================================================================================

