; ================================================================================================
; Konverter von DMX auf tpm2
; Definitionen Register, Konstanten, etc.
; ================================================================================================

; ================================================================================================
; Register definieren
; ------------------------------------------------------------------------------------------------

.def Mathe_L			= R0			; Fr mathematische Berechnungen
.def Mathe_H			= R1

.def SREG_Save			= R2			; Statusregister sichern (Nur ISR!)

.def temp0 				= R16			; Mehrzweck-Temp-Register	
.def temp1 				= R17
.def temp2 				= R18
.def temp3				= R19
.def temp4				= R20

.def itemp0				= R21			; Mehrzweck-Temp-Register nur fr ISRs!
.def itemp1				= R22
.def itemp2				= R23
.def itemp3				= R24

.def flags				= R25			; Div. Flags

; ================================================================================================
; Konstanten/Aliase definieren
; ------------------------------------------------------------------------------------------------

.equ XTAL				= 20000000		; Prozessortakt 20 MHz

.equ BAUD_DMX			= 250000		; Baudrate DMX-Empfang
.equ BAUD_USB			= 250000		; Baudrate USB-Empfang/Senden

.equ DMX_CHANNELS		= 512			; Max. zu empfangende DMX-Kanle
.equ DMX_STARTADRESS	= 1				; DMX-Startadresse

.equ SEDU_PORT			= PortD			; Port fr SEDU intern
.equ SEDU_PIN			= PinD
.equ SEDU_DDR			= DDRD

.equ S_LED				= 5				; Status-LED
.equ RS485DIR			= 6				; Umschaltung RS485-Bustreiber

.equ FL_DMX_FR			= 2				; Flag fr DMX-Frame empfangen

.equ _Bootloader_Start	= 0x7C00		; Startadresse Bootloader im Flash
.equ BOOTSTRING_LENGHT	= 8				; Lnge Startcode fr Bootloader

; ================================================================================================
; RAM-Bereiche definieren
; ------------------------------------------------------------------------------------------------

.DSEG

DMX_Adress_L:			.byte 1			; DMX-Startadresse LB
DMX_Adress_H:			.byte 1			; DMX-Startadresse HB

; ------------------------------------------------------------------------------------------------

tpm2_State:				.byte 1			; Status tpm2-Empfangsroutine
tpm2_Timeout:			.byte 1			; Zhler fr timeout tpm2-Empfangsroutine

DMX_State:				.byte 1			; Status DMX-Empfangsroutine
DMX_Timeout:			.byte 1			; Zhler fr timeout DMX-Empfangsroutine
DMX_L:					.byte 1			; Sicherung Pointer DMX-Routine
DMX_H:					.byte 1			; Sicherung Pointer DMX-Routine

DMX_In_Buffer:			.byte DMX_CHANNELS	; DMX-Empfangspuffer

; ================================================================================================
