; ================================================================================================
; ISR fr DMX-Empfang
; ------------------------------------------------------------------------------------------------

_ISR_Byte_Received_DMX:

		in      SREG_Save, SREG
		push	ZH
		push 	ZL

		lds		ZL, DMX_L						; Pointer holen
		lds		ZH, DMX_H

		lds		itemp0,UCSR1A					; USART-Status und Daten holen
		lds		itemp1,UDR1

		sbrc	itemp0,FE1						; Frame-Error: neuer Durchgang
		rjmp	dmx_frame_error	
		
		lds		itemp0, DMX_State				; Receiver-Status holen

		cpi		itemp0, 1   					; auf Startbyte testen
		breq	dmx_startbyte

  		cpi 	itemp0, 2   					; auf Startadresse warten
		breq    dmx_startadr
  		
 		cpi 	itemp0, 3						; empfangenes Byte speichern
  		brsh	dmx_store_byte

dmx_finish:

		sts		DMX_H, ZH						; Register wieder sichern
		sts		DMX_L, ZL

	 	sts 	DMX_state, itemp0				; Status wieder sichern
			
		pop		ZL
		pop		ZH

		out     SREG, SREG_Save	

		reti			

dmx_startbyte:

		tst 	itemp1	 						; Byte = 0 --> Startbyte, sonst Fehler
		brne 	dmx_err
		inc  	itemp0							; nchster Aufruf: Startadresse checken

		lds 	ZL, DMX_Adress_L 				; Startadresse holen
		lds		ZH, DMX_Adress_H

		ser		itemp2							; Timeout-Zhler starten
		sts		DMX_Timeout, itemp2

		sbi		SEDU_PIN, S_LED					; Status-LED toggeln
		sbr		Flags, (1<<FL_DMX_FR)			; Flag setzen fr Frame empfangen

		rjmp	dmx_finish

dmx_startadr:

		sbiw	ZH:ZL, 1						; Adresse runterzhlen
		brne	dmx_finish						; Startadresse noch nicht erreicht

		ldi 	ZH, high(DMX_In_Buffer)			; Startadresse erreicht, Pointer setzen
		ldi		ZL, low(DMX_In_Buffer)
		inc  	itemp0							; nchster Aufruf: Daten speichern
		
dmx_store_byte:
			
		st		Z+, itemp1

		cpi		ZL, low(DMX_In_Buffer+DMX_Channels)	; empfangene Bytes zhlen
		brne	dmx_finish
		cpi		ZH, high(DMX_In_Buffer+DMX_Channels)
		brne	dmx_finish						; noch nicht durch, Ende

		clr		itemp0							; Alle Bytes empfangen, auf nchsten FE warten

		rjmp	dmx_finish
	
dmx_frame_error:

		ldi 	itemp0, 1						; Frame-Error --> neuer Durchlauf
		ldi 	itemp2, (1<<FE1)				
		sts		UCSR1A, itemp2					; FE-Flag lschen
		rjmp	dmx_finish

dmx_err:

		clr		itemp0							; auf nchsten FE warten
		rjmp	dmx_finish

; ================================================================================================

