; ================================================================================================
; Empfangsroutine USB, prft nur auf Bootloader-Startcode
; ================================================================================================
;
; benutzte Register      : ZL, ZH, werden gesichert, ansonsten itemp-Register
; gem. benutzte Register : keine
; reservierte Register   : siehe unten
;
; Definitionen (zum Kopieren):
;
; ------------------------------------------------------------------------------------------------

_ISR_Byte_Received_USB:

		in		SREG_Save, SREG					; Statusregister sichern
		push	ZL
		push	ZH

		ser		itemp0							; Timeout-Zhler fr USB-Empfang starten
		sts		tpm2_Timeout, itemp0

		lds		itemp1, UDR0					; Empfangenes Byte in itemp1

; ------------------------------------------------------------------------------------------------
; Bootloader-Check
; ------------------------------------------------------------------------------------------------

		lds		itemp2, tpm2_State

		ldi		ZL, low(Bootstring*2)			; Pointer auf Beginn Bootstring setzen
		ldi		ZH, high(Bootstring*2)

		clr		itemp0							; Offset Stringposition addieren
		add		ZL, itemp2
		adc		ZH, itemp0

		lpm		itemp0, Z						; Zeichen holen

		cp		itemp0, itemp1					; mit empfangenem Zeichen vergleichen

		brne	_SUB_CB_Clear					; falsches Zeichen empfangen, Receiver Reset

		inc		itemp2							; passendes Zeichen empfangen, weiter zhlen

		cpi		itemp2, BOOTSTRING_LENGHT		; kompletter String erfolgreich verglichen...?

		brlo	_SUB_CB_Ende					; nein, beim nchsten Aufruf weiter vergleichen

sbi		SEDU_PORT, S_LED					; Status-LED aus


		jmp		_Bootloader_Start				; ja, Bootloader starten

_SUB_CB_Clear:

		clr		itemp2							; nein, weiter checken

; ------------------------------------------------------------------------------------------------

_SUB_CB_Ende:

		sts		tpm2_State, itemp2				; Status wieder sichern

		pop		ZH								; Register wiederherstellen
		pop		ZL
		out		SREG, SREG_Save					; Statusregister wiederherstellen

		reti									; Ende Routine

; ================================================================================================
