; ================================================================================================
; Konverter von DMX auf tpm2
; Timer0-ISR fr Receiver-Timeout etc.
; ================================================================================================

_Timer0OVF:

		in		SREG_Save, SREG					; Statusregister sichern

; ------------------------------------------------------------------------------------------------
; Timeout-Zhler fr Reset DMX-Empfangsroutine
; ------------------------------------------------------------------------------------------------

		lds		itemp0, DMX_Timeout				; Timeout-Zhler DMX holen

		tst		itemp0							; Receiver-Timeout bereits erreicht..?
		breq	_Timer0OVF_DMX_Ende				; ja, Ende

		dec		itemp0							; nein, weiter runter
		brne	_Timer0OVF_DMX_Ende				; noch nicht 0, weiter

		clr		itemp1							; Timeout erreicht, Receiver Reset
		sts		DMX_State, itemp1
		
		cbi		SEDU_PORT, S_LED				; Status-LED an

_Timer0OVF_DMX_Ende:

		sts		DMX_Timeout, itemp0				; Zhler wieder sichern

; ------------------------------------------------------------------------------------------------
; Timeout-Zhler fr Reset USB-Empfangsroutine
; ------------------------------------------------------------------------------------------------

		lds		itemp0, tpm2_Timeout			; Timeout-Zhler tpm2 holen

		tst		itemp0							; Receiver-Timeout bereits erreicht..?
		breq	_Timer0OVF_USB_Ende				; ja, Ende

		dec		itemp0							; nein, weiter runter
		brne	_Timer0OVF_USB_Ende				; noch nicht 0, weiter

		clr		itemp1							; Timeout erreicht, Receiver Reset
		sts		tpm2_State, itemp1
		
_Timer0OVF_USB_Ende:

		sts		tpm2_Timeout, itemp0			; Zhler wieder sichern

; ------------------------------------------------------------------------------------------------

		out		SREG, SREG_Save					; Statusregister wiederherstellen

		reti									; und zurck

; ================================================================================================
